/*
  docgen  Objective C Document Generator
  Copyright (C) 1995  Bill Bereza.
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  
  Email:
  berezaw@river.it.gvsu.edu

  S-mail:
  Bill Bereza
  9526 Judson Rd.
  Ravenna, MI 49451-9427

  */
/* docgen	Objective C Document Generator
 * Copyright (c) 1994 Bill Bereza
 *
 *	$Log:	RTFcrap.c,v $
 * Revision 1.6  95/03/02  03:44:35  berezaw
 * using GNU regex library
 * rewrote recmp() as docgen_recmp()
 * added GPL stuff to each file
 * increase rev. to 0.1.9
 * 
 * Revision 1.5  95/01/30  13:31:40  berezaw
 * added fmakeul and funul
 * 
 * Revision 1.4  95/01/26  15:27:07  berezaw
 * better
 * 
 * Revision 1.3  95/01/26  05:33:51  berezaw
 * changed fputmethodh to handle different types of methods
 * 
 * Revision 1.2  94/11/28  12:08:28  berezaw
 * *** empty log message ***
 * 
 *
 *	$Id: RTFcrap.c,v 1.6 95/03/02 03:44:35 berezaw Exp $
 */

#include "RTFcrap.h"

void fchfontsize(FILE *of, char sz)
{
	fprintf(of, "\n\\fs%d ", sz);
}

void fputhead(FILE *of)
{
	fprintf(of, "{\\rtf0\\ansi{\\fonttbl\\f0\\fnil Times-Roman;\\f2\\fswiss Helvetica;\\f1\\ftech Symbol;\\f3\\fmodern Ohlfs;}\n");
	
	fprintf(of, "\\paperw16220\n");
	fprintf(of, "\\paperh15040\n");
	fprintf(of, "\\margl120\n");
	fprintf(of, "\\margr0\n");
}

void fputmethodl1(FILE *of)
{
	fprintf(of,"\\f2\\fs28\\b\\fi-380\\li2480 ");
}

void fputmethodl2(FILE *of)
{
	fprintf(of, "\\f1\\b0\\fi-760\\li3240 ");
}

void fputcphead(FILE *of)
{
	fprintf(of, "%s ", "\\f0\\b0\\i0\\ulnone\\ql\\fs24\\fi0\\li0\\gray0\\fc0\\cf0\\up0\\dn0");
}

void fputline(FILE *of, char *line)
{
	fprintf(of, "%s\\\n", line);
}

void fputbold(FILE *of, char *line)
{
	fprintf(of, " %s%s\n%s", BOLD, line, UBOLD);
}

void fputivardesc(FILE *of)
{
	fprintf(of,"\\pard\\tx6140\\tx9660\\tx10180\\fs16\\fi-4040\\li6140\\fc0\\cf0 \\\n");
	fprintf(of,"\\\n\\\n");
}

void fchangefont(FILE *of, char fn)
{
	fprintf(of, "\\f%d ", fn);
}

void fputfchar(FILE *of, char fn, char putthechar)
{
	fprintf(of, "\\f%d %c\n", fn, putthechar);
}

void fputeof(FILE *of)
{
	fprintf(of, "}\n");
}

void fmakeul(FILE *of)
{
	fprintf(of,"\n\\ul ");
}

void funul(FILE *of)
{
	fprintf(of,"\n\\ulnone ");
}

void fmakebold(FILE *of)
{
	fprintf(of,"\n\\b ");
}

void funbold(FILE *of)
{
	fprintf(of,"\n\\b0 ");
}

void fmakeitalic(FILE *of)
{
	fprintf(of,"\n\\i ");
}

void fputmethdesc(FILE *of)
{
	fprintf(of,"\\\n\\f2\\b\\fs28 ");
}

void funitalic(FILE *of)
{
	fprintf(of,"\n\\i0 ");
}

void fputstart(FILE *of)
{
	fprintf(of, "\\pard\\tx2480\\tx2860\\tx3240\\fs16\\li2100\\fc0\\cf0 \\\n\\\n\\\n");
	fprintf(of, "\\pard\\f2\\b\\fs56\\li2100\\fc0\\cf0 ");
}

void fputinherith(FILE *of)
{
	fprintf(of,"\\pard\\tx4880\\f0\\b0\\fs16\\fi-2780\\li4880\\fc0\\cf0 \\\n");
	fprintf(of,"\\\n\\\n\\\n");
	fprintf(of,"\\f2\\b\\fs28 Inherits From:\t\n\\f0\\b0 ");
}

void fputconformh(FILE *of, char *con)
{
	fprintf(of,"\\fs16 \\\n");
	fprintf(of,"\\f2\\b\\fs28 Conforms To:\n");
	fprintf(of,"\\f0\\b0 \t%s \\\n", con);
}   

void fputinheritt(FILE *of, char *dec)
{
	fprintf(of,"\\fs16 \\\n");
	fprintf(of,"\\f2\\b\\fs28 Declared In:\n");
	fprintf(of,"\\f0\\b0 \t%s \\\n", dec);
	fprintf(of,"\\f0\\fs16 \\\n");
	fprintf(of,"\\pard\\f2\\b\\li1360\\fc0\\cf0 \\\n");
	fprintf(of,"\\\n\\\n\\\n");
	fprintf(of,"\\fs36 Class Description\\\n");
	fprintf(of,"\\fs16 \\\n");
	fprintf(of,"\\pard\\tx2480\\tx2860\\tx3240\\f0\\b0\\fs28\\li2100\\fc0\\cf0 ");
}

void fputcath(FILE *of)
{
	
	fprintf(of,"\\pard\\tx4880\\f0\\b0\\fs16\\fi-2780\\li4880\\fc0\\cf0 \\\n");
	fprintf(of,"\\\n\\\n\\\n");
	fprintf(of,"\\f2\\b\\fs28 Category Of:\t\n\\f0\\b0 ");
}

void fputcatt(FILE *of, char *dec)
{
	fprintf(of,"\\fs16 \\\n");
	fprintf(of,"\\f2\\b\\fs28 Declared In:\n");
	fprintf(of,"\\f0\\b0 \t%s \\\n", dec);
	fprintf(of,"\\f0\\fs16 \\\n");
	
	fprintf(of,"\\fs16 \\\n");
	fprintf(of,"\\pard\\f2\\b\\li1360\\fc0\\cf0 \\\n");
	fprintf(of,"\\\n\\\n");
	fprintf(of,"\\fs36 Category Description\\\n");
	fprintf(of,"\\fs16 \\\n");
	fprintf(of,"\\pard\\tx2480\\tx2860\\tx3240\\f0\\b0\\fs28\\li2100\\fc0\\cf0 ");
}

void fputihead(FILE *of) 
{
	fprintf(of," \\\n\\pard\\f2\\b\\li1360\\fc0\\cf0 \\\n");
	fprintf(of," \\\n \\\n \\\n");
	fprintf(of,"\\fs36 Instance Variables\\\n \\\n");
	fprintf(of,"\\pard\\tx2860\\f0\\b0\\fs28\\li2100\\fc0\\cf0 ");
}

void fputmethodh(FILE *of, char *kindof)
{
	fprintf(of,"\\pard\\f2\\b\\fs16\\li1360\\fc0\\cf0 \\\n");
	fprintf(of,"\\\n\\\n\\\n");
	fprintf(of,"\\fs36 %s Methods\\\n", kindof);
}

void fputmethodtype(FILE *of)
{
	fprintf(of,"\\fs16 \\\n");
	fprintf(of,"\\pard\\f2\\b\\li1360\\fc0\\cf0 \\\n");
	fprintf(of,"\\\n\\\n\\\n\\\n");
	fprintf(of,"\\fs36 Method Types\\\n");
	fprintf(of,"\\fs16 \\\n");
	fprintf(of, "\\pard\\tx6140\\tx9660\\tx10180\\f0\\b0\\fs28\\fi-4040\\li6140\\fc0\\cf0 	\n");
}
