/* dstring v1.0.0	Dynamic string library
 * Copyright (c) 1994 Bill Bereza
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *
 * To reach the author
 *
 * email:
 *	berezaw@river.it.gvsu.edu	ac368@leo.nmc.edu
 *
 *	$Log:	dstrio.h,v $
 * Revision 1.3  94/12/03  00:09:56  berezaw
 * changed all uses of (char) to (DCHAR)
 * 
 * Revision 1.2  94/11/28  12:04:08  berezaw
 * *** empty log message ***
 * 
 *
 *	@(#)dstrio.h	1.0 (Bill Bereza) 11/15/94
 *	$Header: /Users/berezaw/src/dynstr/RCS/dstrio.h,v 1.3 94/12/03 00:09:56 berezaw Exp $
 */

#ifndef DSTRIO_H
#define DSTRIO_H

#include "dstring.h"
#include <stdio.h>

extern DSTRING 	*fgetds(DSTRING *oldstring, FILE *openedfile);
/* fgetds will get one line of text from the FILE stream
 * and append it to the dstring struct
 *
 * both arguments must be initialized
 *
 * returns pointer to DSTRING
 */

#define	getds(dstring)	fgetds((dstring), stdin)
/* calls fgetds to read from stdin */

extern DCHAR 	*fgetdline(FILE *openedfile);
/* fgetdline invisibly uses a dynamic string and then allocates
 * a character array for it, fgetdline uses fgetds
 *
 * the character array should be an unitialized char pointer
 * FILE should be an initialized file pointer
 *
 * returns a pointer to the array, else NULL on error
 */

#define getdline()	fgetdline(stdin)
/* calls fgetdline to read from stdin */

extern DCHAR 	*fgetdstr(DSTRING *oldstring, FILE *openedfile);
/* fgetdstr reads a line of text into the DSTRING,
 * and allocates character array space
 *
 * the DSTRING and FILE must both be initialized previously
 *
 * returns a pointer to the array, NULL on error
 */

#define getdstr(dstring)	fgetdstr((dstring), stdin)
/* calls fgetdstr to read from stdin */

#endif /* DSTRIO_H */
