/* Docgen can print your copyright header in a special font.
	When it sees COPYRIGHT somewhere before the @implementation,
Copyright (c) 1995 Joe Inc. 
All Rights Reserved.

	It prints the next line as a copyright header.
*/

@implementation aClass
/*
_%Docgen%_ will only use comments where the comment starter is the first character, except for instance variables, where it uses comments that following the declaration.

%*That*% %*way,*% %*you*% %*can*% %*control*% %*which*% %*comments*% %*are*% %*printed.*%

Anything can go here, like

$Revision: 1.6 $

If there is anything to say about the whole class, say so here.
*/

+initialize
/*
Class methods will be listed in seperate heading only if they are in the .m file before any instance methods, *OR* if you having sorting on for method descriptions.
*/
{
	return nil;
}

/*
Docgen v0.3.1 adds the ability to handle comments before and/or after the method name.

You can have comments between the method and the start of the code or you can have comments before the method name. Or you can have docgen parse both.
*/

-init
/*
You don't need to have comments here.
*/
{
	return [super init];
}

-initWith:zippo also:(int)zappo
/*
The *also:* above will be part of the name like it should.
zappo is just a number.

See Also: init
*/
{
	anint=zappo;
	return zippo;
}

// This comment came before the method name.
-setAnint:(int)num
/*
The word num will be italicized in these comments

See Also: This will be printed larger
*/
{
	num=5;
	return self;
}

-setAstring:(char *)string			{ astring=string; return self; }

-(int)anint							{ return anint; }

-_doStuffWith:(void *)magic Thrash:(FILE *)buffy
  /* This method does nasty things with magic and buffy.
   *		
   * It can be made _invisible_ in the documentation with the '-x' option. */
{
	bcopy(magic, buffy, *(123));
	fwrite(magic, 1, 10240, buffy);

	return [super _doStuffWith:buff Thrash:magic];
}

/*
   This comment came first too.
   */
-(char *)astring
/*
Returns a pointer

See Also: free
*/
{
	return astring;
}

-freestring
/*
Just like free
*/
{
	return [self free];
}

-free
/*
Free's astring
*/
{
	if(astring)
		free(astring);
	return [super free];
}

@end
