/*
 * PCN System
 * Author:      Steve Tuecke
 *              Argonne National Laboratory
 *
 * Please see the DISCLAIMER file in the top level directory of the
 * distribution regarding the provisions under which this software
 * is distributed.
 *
 * pcn_pipe.h
 *
 * Header for pipe module.
 */

#ifndef _PCN_INCLUDE_PCN_PIPE_H
#define _PCN_INCLUDE_PCN_PIPE_H

/* Common values for the std?_action arguments of setup_pipe() */
#define STDIO_WITH_DEV_NULL	0
#define STDIO_CREATE		1
#define STDIO_USE_ARGUMENT	2
#define STDIO_USE_CURRENT	3

/* Values for stdin_action argument of setup_pipe() */
#define STDIN_FROM_DEV_NULL	STDIO_WITH_DEV_NULL
#define STDIN_CREATE		STDIO_CREATE
#define STDIN_USE_ARGUMENT	STDIO_USE_ARGUMENT
#define STDIN_USE_CURRENT	STDIO_USE_CURRENT

/* Values for stdout_action argument of setup_pipe() */
#define STDOUT_TO_DEV_NULL	STDIO_WITH_DEV_NULL
#define STDOUT_CREATE		STDIO_CREATE
#define STDOUT_USE_ARGUMENT	STDIO_USE_ARGUMENT
#define STDOUT_USE_CURRENT	STDIO_USE_CURRENT

/* Values for stderr_action argument of setup_pipe() */
#define STDERR_TO_DEV_NULL	STDIO_WITH_DEV_NULL
#define STDERR_CREATE		STDIO_CREATE
#define STDERR_USE_ARGUMENT	STDIO_USE_ARGUMENT
#define STDERR_USE_CURRENT	STDIO_USE_CURRENT

#endif /* _PCN_INCLUDE_PCN_PIPE_H */
